//
// COLORS
//
public final color BACKGROUND_COLOR = color( 255 );
public final color DIVIDER_LINE_COLOR = color( 225 );
public final color MOVE_IMAGE_COLOR = color( 100, 255 );
public final color TITLE_COLOR = #1F78B4;
public final color KEY_COLOR = color( 200 );

public final color SCROLL_BACKGROUND_COLOR = color( 200 );
public final color SCROLL_COLOR = color( 150 );
public final color SCROLL_SELECTED_COLOR = color( 50 );

public final color EMBRYO_MAP_BACKGROUND_COLOR = color( 255 );
public final color EMBRYO_MAP_OUTLINE_COLOR = color( 150 );
public final color EMBRYO_VIEW_TEXT_COLOR = color( 150 );
public final color EMBRYO_VIEW_CELL_COLOR = color( 210 );
public final color EMBRYO_SLIDER_SCENT_COLOR = color( 125 );
public final color EMBRYO_VIEW_COI_COLOR = #B2182B;
public final color EMBRYO_VIEW_IN_CREATED_GROUP_LINE_COLOR = color( 0 );
public final color EMBRYO_VIEW_IN_CREATED_GROUP_FILL_COLOR = color( 255 );
public final color EMBRYO_VIEW_ROLLOVER_COLOR = color( 100 );
public final color EMBRYO_MAP_SLIDER_CONTROL_COLOR = color( 150 );
public final color EMBRYO_MAP_SLIDER_CONTROL_SELECTED_COLOR = color( 50 );

public final color AGGREGATION_FILL_COLOR = color( 240 );
public final color AGGREGATION_OUTLINE_COLOR = color( 150 );
public final color AGGREGATION_TEXT_COLOR = color( 150 );
public final color AGGREGATION_VIEW_SELECTED_COLOR = #B2182B;
public final color AGGREGATION_VIEW_FRAME_COLOR = color( 200 );

public final color CURVEMAP_VIEW_FRAME_COLOR = color( 200 );
public final color CURVEMAP_VIEW_TEXT_COLOR = color( 150 );
public final color CURVEMAP_VIEW_SELECTED_COLOR = #B2182B;
public final color CURVEMAP_VIEW_PLOT_BACKGROUD_COLOR = color( 235 );
public final color CURVEMAP_VIEW_PLOT_FILL_COLOR = color( 200 );
public final color CURVEMAP_VIEW_PLOT_LINE_COLOR = color( 150 );
public final color CURVEMAP_VIEW_PLOT_OUTLINE_COLOR = color( 175 );
public final color CURVEMAP_VIEW_OVERLAY_PLOT_BACKGROUD_COLOR = color( 255 );
public final color CURVEMAP_VIEW_OVERLAY_PLOT_LINE_COLOR = color( 100 );
public final color CURVEMAP_VIEW_OVERLAY_PLOT_ROLLED_OVERLINE_COLOR = #08306B;
public final color CURVEMAP_VIEW_OVERLAY_PLOT_OUTLINE_COLOR = color( 100 );
public final color CURVEMAP_VIEW_OVERLAY_PLOT_TEXT_COLOR = color( 100 );
public final color CURVEMAP_VIEW_DELETE_OUTLINE_COLOR = color( 150 );
public final color CURVEMAP_VIEW_DELETE_FILL_COLOR = color( 100 );

public final color COMP_GROUP_VIEW_PLOT_BACKGROUND_COLOR = color( 255 );
public final color COMP_GROUP_VIEW_PLOT_FILL_COLOR = color( 220 );
public final color COMP_GROUP_VIEW_PLOT_OUTLINE_COLOR = color( 200 );
public final color COMP_GROUP_VIEW_PLOT_SELECTED_COLOR = color( 175 );
public final color COMP_GROUP_VIEW_PLOT_BBOX_COLOR = color( 100 );

public final color SAVE_LOAD_VIEW_TEXT_BOX_FILL_COLOR = color( 235 );
public final color SAVE_LOAD_VIEW_TEXT_BOX_SELECTED_FILL_COLOR = color( 255 );
public final color SAVE_LOAD_VIEW_TEXT_BOX_TEXT_COLOR = color( 150 );
public final color SAVE_LOAD_VIEW_TEXT_BOX_OUTLINE_COLOR = color( 175 );
public final color SAVE_LOAD_VIEW_TRIANGLE_FILL_COLOR = color( 235 );
public final color SAVE_LOAD_VIEW_TRIANGLE_SELECTED_FILL_COLOR = color( 100 );
public final color SAVE_LOAD_VIEW_TRIANGLE_OUTLINE_COLOR = color( 100 );
public final color SAVE_LOAD_VIEW_BUTTON_OUTLINE_COLOR = color( 150 );
public final color SAVE_LOAD_VIEW_BUTTON_FILL_COLOR = color( 100 );



public final color[] COLORMAP_1 = { #F7FCF0, // yellow to blue --- GnBu
                                    #E0F3DB, 
                                    #CCEBC5, 
                                    #A8DDB5,
                                    #7BCCC4,
                                    #4EB3D3,
                                    #2B8CBE,
                                    #0868AC,
                                    #084081 };
public final color[] COLORMAP_2 = { #FFFFD9, // more yellowish to darker blue --- YlGnBu
                                    #EDF8B1, 
                                    #C7E9B4, 
                                    #7FCDBB,
                                    #41B6C4,
                                    #1D91C0,
                                    #225EA8,
                                    #253494,
                                    #081D58 };                                    
public final color[] COLORMAP_3 = { #FFFFCC, // yellow to rust --- YlOrRd
                                    #FFEDA0, 
                                    #FED976, 
                                    #FEB24C,
                                    #FD8D3C,
                                    #FC4E2A,
                                    #E31A1C,
                                    #BD0026,
                                    #800026 };  
public final color[] COLORMAP_4 = { #FFFFE5, // more yellowish to darker green --- YlGn
                                    #F7FCB9, 
                                    #D9F0A3, 
                                    #ADDD8E,
                                    #78C679,
                                    #41AB5D,
                                    #238443,
                                    #006837,
                                    #004529 };  
public final color[] COLORMAP_5 = { #FFFFE5, // more yellowish to brown --- YlOrBr
                                    #FFF7BC, 
                                    #FEE391, 
                                    #FEC44F,
                                    #FE9929,
                                    #EC7014,
                                    #CC4C02,
                                    #993404,
                                    #662506 };      
public final color[] COLORMAP_6 = { #8C510A, // diverging --- BrBG
                                    #BF812D, 
                                    #DFC27D, 
                                    #F6E8C3,
                                    #C7EAE5,
                                    #80CDC1,
                                    #35978F,
                                    #01665E };       
public final color[] COLORMAP_CATAGORICAL = { #FF7F00, 
                                              #6A3D9A,
                                              #1F78B4, 
                                              #33A02C, 
                                              #FB9A99,
                                              #A6CEE3,
                                              #B2DF8A,
                                              #FDBF6F,
                                              #CAB2D6 };  
                                    

//
// SIZES
//
public static final int WINDOW_BORDER_WIDTH = 30;
public static final int DIVIDER_LINE_WIDTH = 4;
public static final int PDF_OFFSET = 4;

public static final int SCROLL_WIDTH = 10;
public static final int SCROLL_OFFSET = 10;
public static final int SCROLL_LINE_WEIGHT = 1;
public static final int SCROLL_BAR_LINE_WEIGHT = 5;

public static final int EMBRYO_MAP_OUTLINE_WEIGHT = 1;
public static final int EMBRYO_MAP_WIDTH = 500;
public static final int EMBRYO_VIEW_CELL_WIDTH = 4;
public static final int EMBRYO_VIEW_CELL_HALF_WIDTH = 2;
public static final int EMBRYO_VIEW_ROLLED_OVER_CELL_WIDTH = 12;
public static final int EMBRYO_VIEW_ROLLED_OVER_CELL_WEIGHT = 2;
public static final int EMBRYO_VIEW_CELL_STROKE_WEIGHT = 1;
public static final int EMBRYO_TICK_LENGTH = EMBRYO_VIEW_CELL_WIDTH;
public static final int EMBRYO_MAP_BORDER = EMBRYO_TICK_LENGTH+10;
public static final int EMBRYO_VIEW_SLIDER_WIDTH = 20;
public static final int EMBRYO_VIEW_SLIDER_CONTROLS_WIDTH = 10;
public static final int EMBRYO_VIEW_SLIDER_BORDER = 20;

public static final int AGGREGATION_VIEW_HEIGHT = 120;
public static final int AGGREGATION_VIEW_OUTLINE_WEIGHT = 1;
public static final int AGGREGATION_VIEW_SELECTED_OUTLINE_WEIGHT = 2;
public static final int AGGREGATION_VIEW_BORDER = 20;
public static final int AGGREGATION_IMG_BORDER = 10;
public static final int AGGREGATION_VIEW_FRAME_WEIGHT = 1;
public static final int AGGREGATION_SCROLL_TICK_LENGTH = EMBRYO_VIEW_CELL_WIDTH*2;

public static final int CURVEMAP_VIEW_FRAME_WEIGHT = 1;
public static final int CURVEMAP_VIEW_TAB_WIDTH = 136;
public static final int CURVEMAP_VIEW_TAB_HEIGHT = 20;
public static final int CURVEMAP_VIEW_TAB_OFFSET = 8;
public static final int CURVEMAP_VIEW_FILLED_TIMESERIES_WIDTH = 30;
public static final int CURVEMAP_VIEW_PLOT_LINE_WEIGHT = 1;
public static final int CURVEMAP_VIEW_PLOT_OUTLINE_WEIGHT = 1;
public static final int CURVEMAP_VIEW_OVERLAY_PLOT_LINE_WEIGHT = 1;
public static final int CURVEMAP_VIEW_OVERLAY_PLOT_OUTLINE_WEIGHT = 1;
public static final int CURVEMAP_VIEW_PLOT_OFFSET = 8;
public static final int CURVEMAP_VIEW_INSET = 50;
public static final int CURVEMAP_VIEW_COI_BORDER = 24;
public static final int CURVEMAP_VIEW_GROUP_CELL_BORDER = 8;
public static final int CURVEMAP_VIEW_OVERLAY_BORDER = 24;
public static final int CURVEMAP_VIEW_ROLLED_OVER_WEIGHT = 2;
public static final int CURVEMAP_VIEW_COMP_GROUP_MAP_BORDER = 0;
public static final int CURVEMAP_VIEW_DELETE_COLUMN_WIDTH = 24;
public static final int CURVEMAP_VIEW_DELETE_OUTLINE_WIDTH = 10;
public static final int CURVEMAP_VIEW_DELETE_FILL_WIDTH = 6;
public static final int CURVEMAP_VIEW_DELETE_OUTLINE_WEIGHT = 1;
public static final int CURVEMAP_VIEW_DELETE_BUTTON_WIDTH = 40;
public static final int CURVEMAP_VIEW_DELETE_BUTTON_HEIGHT = 12;
public static final int CURVEMAP_VIEW_SCROLL_OFFSET = 15;
public static final int CURVEMAP_VIEW_PANE_BORDER = 10;
public static final int CURVEMAP_VIEW_DIVIDER_LINE_MIN_MAX = 100;

public static final int COMP_GROUP_VIEW_SLIDER_WIDTH = 10;
public static final int COMP_GROUP_VIEW_SLIDER_BORDER = 10;
public static final int COMP_GROUP_VIEW_ROLLED_OVER_CELL_WIDTH = 8;
public static final int COMP_GROUP_MAX_MAP_WIDTH = 35;
public static final int COMP_GROUP_VIEW_PLOT_BAR_WIDTH = 2;
public static final int COMP_GROUP_VIEW_PLOT_OFFSET = 40;

public static final int AGGREGATION_NUM_COMP_GROUP_CELLS_TO_RENDER = 10;

public static final int SAVE_LOAD_VIEW_OFFSET = 14;
public static final int SAVE_LOAD_VIEW_LABEL_OFFSET = 20;
public static final int SAVE_LOAD_VIEW_TRIANGLE_HEIGHT = 8;
public static final int SAVE_LOAD_VIEW_TEXT_BOX_HEIGHT = 12;
public static final int SAVE_LOAD_VIEW_TEXT_BOX_MAX_WIDTH = 300;
public static final int SAVE_LOAD_VIEW_BUTTON_WIDTH = 40;
public static final int SAVE_LOAD_VIEW_BUTTON_HEIGHT = 12;
public static final int SAVE_LOAD_VIEW_OUTLINE_WEIGHT = 1;
public static final int SAVE_LOAD_VIEW_LOAD_LINE_HEIGHT = 12;
public static final int SAVE_LOAD_VIEW_LOADED_GROUPS_OFFSET = 6;


//
// DIMENSIONS
//
public static int NUM_GENES;
public static int NUM_TIMESTEPS;
public static int NUM_EMBRYOS;
public static int NUM_AGGREGATIONS;


//
// GLOBAL (UNCHANGING) VARIABLES
//
public static PFont _pixel_font_8;
public static PFont _pixel_font_8b;
public static PFont _verdana_font_16;
public static PFont _verdana_font_30;

public static String[] _gene_names;
public static String[] _timestep_names;
public static Embryo[] _embryos;
public static Aggregation[] _aggregations; 
public static Group _created_group;

public static ArrayList _existing_groups = new ArrayList();
public static ArrayList _initial_group_files = new ArrayList();

public static color[] _selected_colormap;

// OTHER GLOBAL VARIABLES
public int _selected_aggregation = 0;
public boolean _use_text_offset = true;
boolean _embryo_map_hover = false;
boolean _comp_group_map_hover = false;
boolean _curvemap_divider_line_selected = false;
boolean _curvemap_divider_line_hoover = false;
boolean _invert_colormap = false;








